package Tests::check_promisc;

use Tests::Base;
@ISA = qw( Tests::Base );

sub execute
{
	my $self = shift;

	return( $self -> probe_return( undef, 
		$self -> opt( 'dev' ),
	) );
}

1;

__END__

=head1 NAME

Tests::check_promisc - checks if network device is in promisc mode, requires probe

=head1 SYNOPSIS

	<check_promisc dev="eth0"/>

=head1 DESCRIPTION

Checks for network devices being put into promisc mode.  Helpful to possibly catch
unwanted system activity, possibly by someone who administers a machine.

Uses /sbin/ifconfig on the remote machine, at least under linux.  You should probably
also use md5_check on /sbin/ifconfig to make sure it's not tampered with.

=head2 dev

The device name, under linux this is eth*

=head1 SEE ALSO

sentinel, probe, librarian, sentinel.conf

=head1 AUTHOR

Steve Slaven - http://hoopajoo.net
