package Tests::auth_radius;

use Tests::Base;
@ISA = qw( Tests::Base );

use Authen::Radius;

# Checks if a radius server will authenticate, needs user/pass/secret
# Also requires Authen::Radius
sub execute
{
	my $self = shift;

	my $user = $self -> opt( 'user' );

	# I don't know wtf is up here, but if I pass a variable, it don't work.
	# If I pass a variable initialized from a static string, it does.
	# So, this is just "$user = '<value of user>'" eval'd at runtime.  stupid.
	eval( "\$user = '$user'" );

	my $r = new Authen::Radius(
		Host => $self -> host_addr(),
		Secret =>$self -> opt( 'secret' ) 
	);

	if( $r -> check_pwd( $user, $self -> opt( 'pass' ) ) )
	{
		return( 0 );
	}else
	{
		$self -> message( "Error: auth failed: " . $r -> strerror() );
		return( 1 );
	}
}

1;

__END__

=head1 NAME

Tests::auth_radius - validates that radius authentication is functioning

=head1 SYNOPSIS

	<auth_radius user="user" pass="password" secret="secret"/>

Requires Authen::Radius perl module.

=head1 DESCRIPTION

The auth_radius plugin will test that radius authentication is functioning.  The
username and password should be for a known user that will always work, because
the test fails if authentication fails.

It was created because the Lucent radiusd sometimes freaks out and stops authenticating
for no reason.  Good for use with chaining "onfail" to restart the radius server
since restarting the radiusd usually fixes the problem, although caching problems
have also been encountered that required more extreme measures.

=head2 user

The username to be authenticated

=head2 pass

The password for the username

=head2 secret

The shared secret needed to talk to the radius server

=head1 SEE ALSO

sentinel, probe, librarian, sentinel.conf

=head1 AUTHOR

Steve Slaven - http://hoopajoo.net
